//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_width1 1
#property indicator_width2 1

//
//
//
//
//

extern int    Risk            = 3;
extern double ArrowsGap       = 1.0;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = true;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";

double arrDn[];
double arrUp[];
double wpr[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,arrDn); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,108);
   SetIndexBuffer(1,arrUp); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,108);
   SetIndexBuffer(2,wpr);
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   double x1 = 67.0+Risk;
   double x2 = 33.0-Risk;
   for (int i=limit; i>=0 ; i--)
   {
      int    period = 3+Risk*2;
      double range  = 0; for (int k=0; k<10; k++) range += High[i+k]-Low[i+k]; range /= 10.0;
      bool   found1 = false; for (k=0; k<6 && !found1; k++) found1 = (MathAbs(Open[i+k] -Close[i+k+1])>=range*2.0);
      bool   found2 = false; for (k=0; k<9 && !found2; k++) found2 = (MathAbs(Close[i+k+3]-Close[i+k])>=range*4.6);
             if (found1) period = 3;
             if (found2) period = 4;
                  wpr[i]   = 100+iWPR(NULL,0,period,i);

      //
      //
      //
      //
      //
               
      arrDn[i] = EMPTY_VALUE;
      arrUp[i] = EMPTY_VALUE;
         if (wpr[i] < x2) { for (k=1; i+k<Bars && wpr[i+k]>=x2 && wpr[i+k]<=x1;) k++; if (wpr[i+k]>x1) arrDn[i] = High[i]+range*ArrowsGap; }
         if (wpr[i] > x1) { for (k=1; i+k<Bars && wpr[i+k]>=x2 && wpr[i+k]<=x1;) k++; if (wpr[i+k]<x2) arrUp[i] = Low[i] -range*ArrowsGap; }
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int whichBar=0;
      else      whichBar=1;            
      if (arrUp[whichBar]!= EMPTY_VALUE) doAlert("trend buy");   
      if (arrDn[whichBar]!= EMPTY_VALUE) doAlert("trend sell"); 
   }      
   return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="";
   static datetime previousTime=0;
   string          message;
   
   if (previousAlert != doWhat || previousTime != Time[0])
   {
       previousAlert = doWhat;
       previousTime  = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Trend Signal : ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Trend Signal "),message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Trend Signal " +" "+message));
          if (alertsSound)   PlaySound(soundFile);
   }
}
   